%error = forceRequiredAddOn("Gamemode_TeamDeathmatch"); //Needed to run game modes
if(%error == $Error::AddOn_NotFound)
{
	error("Gamemode_KOTH - required Add-On Gamemode_TeamDeathmatch not found");
	return;
}
datablock fxDTSBrickData(brickKOTHCPTData : brick8x8FData)
{
	category = "SpaceMods";
	subCategory = "King of the Hill";
	uiName = "Tiny Capture Point";			
	kothCP = 1;
};
datablock fxDTSBrickData(brickKOTHCPSData : brick16x16FData)
{
	category = "SpaceMods";
	subCategory = "King of the Hill";
	uiName = "Small Capture Point";			
	kothCP = 1;
};
datablock fxDTSBrickData(brickKOTHCPData : brick32x32FData)
{
	category = "SpaceMods";
	subCategory = "King of the Hill";
	uiName = "Capture Point";			
	kothCP = 1;
};
datablock fxDTSBrickData(brickKOTHCPLData : brick64x64FData)
{
	category = "SpaceMods";
	subCategory = "King of the Hill";
	uiName = "Large Capture Point";			
	kothCP = 1;
};
datablock TriggerData(KOTHTriggerData)
{
	tickPeriodMS = 1000;
};
function KOTHTriggerData::onEnterTrigger(%this,%trigger,%user)
{
	if(!isObject(%trigger.spawnBrick) || !%trigger.spawnBrick.isColliding() || (GameModeStorerSO.modeTitle[%user.client.minigame.gameMode] !$= "TDM King of the Hill" && GameModeStorerSO.modeTitle[%user.client.minigame.gameMode] !$= "FFA King of the Hill") || (%user.client.minigame.owner != %trigger.spawnBrick.getGroup().client && !%user.client.minigame.useAllPlayerBricks))
		return;
	%trigger.playerSet.add(%user);
}
function KOTHTriggerData::onLeaveTrigger(%this,%trigger,%user)
{
	if(%trigger.playerSet.isMember(%user))
		%trigger.playerSet.remove(%user);
}
function KOTHTriggerData::onTickTrigger(%this,%trigger)
{
	if(!isObject(%trigger.spawnBrick))
		return;
	%mini = %trigger.spawnBrick.getGroup().client.minigame;
	if(isObject(%mini) && %mini.owner == %trigger.spawnBrick.getGroup().client && %trigger.spawnBrick.isColliding())
	{
		switch$(GameModeStorerSO.modeTitle[%mini.gameMode])
		{
			case "FFA King of the Hill":
				if(%trigger.playerSet.getCount() < 1 || %mini.roundWon)
				{
					return;
				}
				%capturer = %trigger.playerSet.getObject(0);
				if(isObject(%capturer))
				{
					for(%i=0;%i<%mini.numMembers;%i++)
					{
						if(%mini.member[%i] == %capturer.client)
						{
							%foundit = 1;
							break;
						}
					}
					if(%foundit)
					{
						cancel(%trigger.noCapCenterPrint);
						%mini.captureTime[%i] += 1;
						%mini.centerPrintAll("<just:right>KOTH<br>\c6" @ %capturer.client.getPlayerName() @ ": \c0" @ %mini.captureTime[%i] @ "\c6 seconds",-1);
						if(%mini.captureTime[%i] >= %mini.tdmModeRule[0])
						{
							%capturer.client.tdmRoundsWon++;
							%mini.messageAll('',"\c3" @ %capturer.client.getPlayerName() @ "\c5 won this round. Resetting in five seconds...");
							%mini.roundWon = 1;
							%mini.roundSwapTeams = 0;
							for(%i=0;%i<%mini.numMembers;%i++)
							{
								%cl = %mini.member[%i];
								if(isObject(%cl.player))
								{
									%cl.setControlObject(%cl.camera);
									%cl.camera.setMode("Corpse",%cl.player);
									%cl.tdmCameraTarget = 0;
								}
								else
								{
									%cl.getAutoCameraTarget();
								}
							}
							%mini.schedule(5000,reset,%mini.owner);
						}
						else
						{
							%trigger.noCapCenterPrint = %mini.schedule(2000,"centerPrintAll","<just:right>KOTH<br>\c6No-one is capturing",-1);
						}
						return;
					}
				}
			case "TDM King of the Hill":
				if(%trigger.playerSet.getCount() < 1 || %mini.roundWon)
				{
					return;
				}
				%capturer = %trigger.playerSet.getObject(0);
				if(isObject(%capturer) && %mini.teamExists[%capturer.client.tdmTeam])
				{
					cancel(%trigger.noCapCenterPrint);
					%mini.captureTime[%capturer.client.tdmTeam] += 1;
					%mini.centerPrintAll("<just:right>KOTH<br><color:" @ RGBtoHEX(getColorIDTable(%mini.teamCol[%capturer.client.tdmTeam])) @ ">" @ %mini.teamName[%capturer.client.tdmTeam] @ "\c6: \c0" @ %mini.captureTime[%capturer.client.tdmTeam] @ "\c6 seconds",-1);
					if(%mini.captureTime[%capturer.client.tdmTeam] >= %mini.tdmModeRule[0])
					{
						%mini.roundEnd(%capturer.client.tdmTeam,0,%capturer.client);
					}
					else
					{
						%trigger.noCapCenterPrint = %mini.schedule(2000,"centerPrintAll","<just:right>KOTH<br>\c6No-one is capturing",-1);
					}
					return;
				}
		}
		%mini.centerPrintAll("<just:right>KOTH<br>\c6No-one is capturing",-1);
	}
}
package Gamemode_KOTH
{
	function fxDtsBrick::onPlant(%brick)
	{
		Parent::onPlant(%brick);
		if(%brick.dataBlock.kothCP)
		{
			%brick.createTriggerZone(KOTHTriggerData);
			if(isObject(%brick.triggerZone))
			{
				%brick.triggerZone.playerSet = new SimSet();
			}
		}
	}
	function fxDtsBrick::onRemove(%brick)
	{
		Parent::onRemove(%brick);	
		if(%this.dataBlock.kothCP)
		{
			if(isObject(%this.triggerZone.playerSet))
				%this.triggerZone.playerSet.delete();
			if(isObject(%this.triggerZone))
				%this.triggerZone.delete();
		}
	}
};
activatePackage(Gamemode_KOTH);
registerGameMode("FFA King of the Hill","FFAKOTH",0,0,0);
setGameModeHelp("FFA King of the Hill","Add-Ons/Gamemode_KOTH/kothffa.txt");
addGameModeRule("FFA King of the Hill","Time","int 1 3600",15);
function GameMode_FFAKOTH_onModeStart(%mini,%client)
{
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%mini.captureTime[%i] = 0;
	}
	%mini.centerPrintAll("<just:right>KOTH<br>\c6No-one is capturing",-1);
	%mini.messageAll("\c5This round you must hold the capture point for \c3" @ %mini.tdmModeRule[0] @ "\c5 seconds to win.");
}
function GameMode_FFAKOTH_onModeEnd(%mini,%client)
{
	%mini.centerPrintAll("",1);
}
function GameMode_FFAKOTH_onMiniReset(%mini,%client)
{
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%mini.captureTime[%i] = 0;
	}
	%mini.messageAll("\c5This round you must hold the capture point for \c3" @ %mini.tdmModeRule[0] @ "\c5 seconds to win.");
}
function GameMode_FFAKOTH_onModeUpdateRule0(%mini,%rulevalue,%oldvalue,%modestart)
{
	return 1;
}
function GameMode_FFAKOTH_onAddMember(%mini,%client)
{
	%mini.captureTime[%mini.numMembers-1] = 0;
}
registerGameMode("TDM King of the Hill","TDMKOTH",1,0,0);
setGameModeHelp("TDM King of the Hill","Add-Ons/Gamemode_KOTH/kothtdm.txt");
addGameModeRule("TDM King of the Hill","Time","int 1 3600",15);
function GameMode_TDMKOTH_onModeStart(%mini,%client)
{
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
		{
			%mini.captureTime[%i] = 0;
		}
	}
	%mini.centerPrintAll("<just:right>KOTH<br>\c6No-one is capturing",-1);
	%mini.messageAll("\c5This round your team must hold the capture point for \c3" @ %mini.tdmModeRule[0] @ "\c5 seconds to win.");
}
function GameMode_TDMKOTH_onModeEnd(%mini,%client)
{
	%mini.centerPrintAll("",1);
}
function GameMode_TDMKOTH_onMiniReset(%mini,%client)
{
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
		{
			%mini.captureTime[%i] = 0;
		}
	}
	%mini.messageAll("\c5This round your team must hold the capture point for \c3" @ %mini.tdmModeRule[0] @ "\c5 seconds to win.");
}
function GameMode_TDMKOTH_onModeUpdateRule0(%mini,%rulevalue,%oldvalue,%modestart)
{
	return 1;
}